<template>
  <header class="py-2">
    <div
      id="navbarNav"
      class="offcanvas offcanvas-start"
      :aria-hidden="!isVisibleMobileMenu"
      :aria-modal="isVisibleMobileMenu"
      :class="{ 'show visible': isVisibleMobileMenu }"
      :role="isVisibleMobileMenu ? 'dialog' : null"
    >
      <div class="offcanvas-header">
        <button
          type="button"
          class="btn-close"
          aria-label="Close"
          @click="isVisibleMobileMenu = false"
        ></button>
      </div>
      <div class="offcanvas-body">
        <ul class="list-unstyled">
          <li><nuxt-link to="/about">О проекте</nuxt-link></li>
          <li><nuxt-link to="/selections">Подборки</nuxt-link></li>
        </ul>
        <hr />
        <category-list :categories="categories" class="list-unstyled" />
        <hr />
        <div class="d-flex align-items-center mt-4">
          <a href="#" class="text-dark text-decoration-none">
            <i class="icon-socials-telegram"></i>
          </a>
        </div>
      </div>
    </div>
    <div
      class="d-flex flex-wrap align-items-center justify-content-between"
      :class="[isUserLayout ? 'container-fluid' : 'container']"
    >
      <button
        type="button"
        class="navbar-toggler d-flex d-md-none"
        aria-controls="navbarNav"
        aria-expanded="false"
        aria-label="Toggle navigation"
        @click="isVisibleMobileMenu = true"
      >
        <i class="icon-burger"></i>
      </button>

      <div class="d-none d-md-flex align-items-center col-auto mb-2 mb-md-0">
        <a href="#" class="text-dark text-decoration-none">
          <i class="icon-socials-telegram"></i>
        </a>
      </div>

      <ul class="nav col-12 col-md-auto mb-2 mb-md-0 d-none d-md-flex">
        <li>
          <nuxt-link to="/" class="nav-link px-2 link-secondary"
            >Главная</nuxt-link
          >
        </li>
        <li>
          <nuxt-link to="/about" class="nav-link px-2 link-dark"
            >О проекте</nuxt-link
          >
        </li>
        <li>
          <nuxt-link to="/selections" class="nav-link px-2 link-dark"
            >Подборки</nuxt-link
          >
        </li>
      </ul>

      <div class="d-block d-md-none current-page">{{ title }}</div>

      <div class="col-auto">
        <template v-if="$store.state.auth.loggedIn">
          <a
            data-toggle="modal"
            class="btn btn-link p-0 d-block d-sm-none"
            href="#userProfileModal"
          >
            <span class="d-none d-lg-inline-flex me-3">{{
              user.username
            }}</span>
            <base-avatar :src="user.avatar" />
          </a>
          <base-dropdown class="d-none d-sm-block">
            <template #placeholder>
              <span class="d-none d-lg-inline-flex me-3">{{
                user.username
              }}</span>
              <base-avatar :src="user.avatar" />
            </template>
            <template #menu>
              <li class="dropdown-item">
                <nuxt-link to="/profile" :prefetch="false"
                  >Мой профиль</nuxt-link
                >
              </li>
              <li class="dropdown-item">
                <a
                  href="/"
                  @click.prevent="() => $store.dispatch('authService/logout')"
                  >Выйти</a
                >
              </li>
            </template>
          </base-dropdown>
        </template>
        <template v-else>
          <button class="btn btn-link p-0" @click="openPopup">
            <i class="icon-user"></i>
          </button>
        </template>
      </div>
    </div>

    <popup-auth v-if="currentPopup" />
  </header>
</template>

<script>
import { mapState } from 'vuex'

import PopupAuth from '@/components/popups/PopupAuth.vue'

import { TypesPopup } from '@/constants/store.types'
import { HEADER_AUTH } from '@/constants/popups'
export default {
  name: 'TheHeader',
  components: { PopupAuth },
  /**
   * @typedef Data
   * @property {Object.<string, string>} popups
   * @property {Boolean} [isVisibleMobileMenu=false]
   */
  /** @type {Data} */
  data() {
    return {
      isVisibleMobileMenu: false,
    }
  },
  computed: {
    ...mapState({
      loading: (state) => state.loading,
      title: (state) => state.title,
      user: (state) => state.auth.user,
      categories: (state) => state.categories.categories,
      currentPopup: (state) => state.popup.currentPopup === HEADER_AUTH,
    }),
    /** @return {String} Текущий файл разметки */
    isUserLayout() {
      return this.$nuxt.$data.layoutName === 'user'
    },
  },
  methods: {
    openPopup() {
      this.$store.commit(TypesPopup.mutations.OPEN_POPUP, HEADER_AUTH)
    },
  },
}
</script>
